| Qore DiscordDataProvider Module Reference 2.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Protected Member Functions | List of all members
DiscordDataProvider::DiscordDataProvider Class Reference

The Discord data provider class. More...

`#include <DiscordDataProvider.qc.dox.h>`

Inheritance diagram for DiscordDataProvider::DiscordDataProvider:
[legend]

## Public Member Functions
| constructor (*hash< auto > options)
| Creates the object from constructor options.
| constructor (DiscordRestClient rest)
| Creates the object from a DiscordRestClient.
| constructor (DiscordRestConnection conn)
| Creates the object from a DiscordRestClient.
*list< hash< DataProvider::DataProviderSummaryInfo > > | getChildProviderSummaryInfo ()
| Return data provider summary info.
*string | getDesc ()
| Returns the data provider description.
string | getName ()
| Returns the data provider name.
Public Member Functions inherited from DiscordDataProvider::DiscordDataProviderBase
| constructor ()
| Creates the object.
| constructor (DiscordRestClient rest, *Logger::LoggerInterface logger)
| Creates the object.
| constructor (DiscordRestConnection conn, *Logger::LoggerInterface logger)
| Creates the object.
| setLogger (*LoggerInterface logger)
| Accepts a LoggerInterface object for logging (or clears it)

## Static Public Member Functions
static DiscordRestClient::DiscordRestClient | getRestConnection (*hash< auto > options)
| Returns a DiscordRestClient connection from the options.
static | registerChild (string name, code generator)
| Registers a child data provider.
Static Public Member Functions inherited from DiscordDataProvider::DiscordDataProviderBase
static | threadWait (date wait_period)
| Wait for a given period of time.

## Public Attributes
const | ConstructorOptions = ...
| Constructor options.
Public Attributes inherited from DiscordDataProvider::DiscordDataProviderBase
const | MaxIoRetries = 5
| Max retries.
const | RetrySet = ...
| IO errors for REST retries.

## Static Public Attributes
static hash< DataProviderInfo > | ProviderInfo
| Provider info.

## Protected Member Functions
*DataProvider::AbstractDataProvider | getChildProviderImpl (string name)
| Returns the given child provider or NOTHING if the given child is unknown.
*list< string > | getChildProviderNamesImpl ()
| Returns a list of child data provider names, if any.
hash< DataProvider::DataProviderInfo > | getStaticInfoImpl ()
| Returns data provider static info.
Protected Member Functions inherited from DiscordDataProvider::DiscordDataProviderBase
hash< auto > | doRestCommand (string method, string path, auto body, reference< hash< auto > > info)
| Makes a REST call and returns the response; handles rate limit responses.
hash< auto > | getGuild (string id)
| Retrieves info for the given guild; must be accessible to the calling user.
bool | retry (hash< ExceptionInfo > ex, reference< int > retries)
| Returns True if the error indicates that the operation should be retried.

## Additional Inherited Members
Protected Attributes inherited from DiscordDataProvider::DiscordDataProviderBase
*DiscordRestConnection | conn
| The connection object used to create the REST client.
*DiscordRestClient | rest
| The REST client object for API calls.

## Detailed Description

The Discord data provider class.

## Member Function Documentation

## ◆ getChildProviderImpl()

*DataProvider::AbstractDataProvider DiscordDataProvider::DiscordDataProvider::getChildProviderImpl | ( | string | name | ) |
| protected

Returns the given child provider or NOTHING if the given child is unknown.

Returns
  the given child provider or NOTHING if the given child is unknown

See also
  getChildProviderEx()

## ◆ getChildProviderNamesImpl()

*list< string > DiscordDataProvider::DiscordDataProvider::getChildProviderNamesImpl | ( |  | ) |
| protected

Returns a list of child data provider names, if any.

Returns
  a list of child data provider names, if any

## ◆ registerChild()

static DiscordDataProvider::DiscordDataProvider::registerChild | ( | string | name,
|  | code | generator )
| static

Registers a child data provider.

Parameters

  name | the child's name
  generator | code to generate the child; prototype: sub (string name, AbstractConnection conn) {}